package com.example.demo.Controller;

import com.example.demo.Entity.Game;
import com.example.demo.Service.GameService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.xml.ws.Response;
import java.util.Collection;

@RestController
@CrossOrigin
//@CrossOrigin(origins = {"http://localhost:8100","http://localhost:8080", "http://192.168.3.158:8100"})
public class GameController {

    private GameService gameService;

    @Autowired
    public GameController(GameService gameService) {
        this.gameService = gameService;
    }

    @PostMapping( value = "/games")
    public Game createGame(@RequestBody Game game) throws Exception{
        return this.gameService.createGame(game);
    }

    @GetMapping ( value = "/games")
    public Collection<Game> findAllGames(){
        return gameService.findAllGames();
    }

    @GetMapping(value="/games/id/{gameId}")
    public Game findGameById(@PathVariable Long gameId){
        return gameService.findGameById(gameId);
    }

//    @GetMapping(value = "/games/user/{userId}")
//    public Collection<Game>

    @GetMapping(value="/games/name/{gameName}")
    public Long getGameByName(@PathVariable String gameName){
        return gameService.getGameByName(gameName);
    }

    @GetMapping (value = "/games/{platform}")
    public Collection<Game> getGamesByPlatform(@PathVariable String platform){
        return gameService.getGamesByPlatform(platform);
    }

    @DeleteMapping (value = "/games/{gameId}")
    public Game deleteGame(@PathVariable Long gameId){
        return gameService.deleteGame(gameId);
    }

    @PutMapping (value = "/games/{gameId}")
    public Game updateGame(@PathVariable Long gameId, @RequestBody Game game){
        return gameService.updateGame(gameId, game);
    }

}
