package com.example.demo.Controller;

import com.example.demo.Entity.Game;
import com.example.demo.Entity.User;
import com.example.demo.Service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;

import java.util.Collection;

@RestController
@CrossOrigin
//@CrossOrigin(origins = {"http://localhost:8100","http://localhost:8080","http://192.168.3.158:8100"})
public class UserController {

    private UserService userService;


    @Autowired
    public UserController(UserService userService) {
        this.userService = userService;

    }

    @PostMapping( value = "/users/register")
    public User createUser(@RequestBody User user){
        return this.userService.createUser(user);
    }

    @GetMapping( value = "/users/{userId}")
    public User findUserById(@PathVariable Long userId){
        return this.userService.findUserById(userId);
    }


    @GetMapping( value = "/users")
    public Collection<User> findAllUsers(){
        return this.userService.findAllUsers();
    }

    @GetMapping( value = "/users/email/{emailField}")
    public User findByEmail(@PathVariable String emailField){
        return this.userService.findByEmail(emailField);
    }

    @PutMapping( value = "/users/{userId}/username")
    public User updateUserName(@RequestBody String newName, @PathVariable Long userId){
        return this.userService.updateUserName(newName, userId);
    }

    @DeleteMapping(value="/users/{userId}")
    public void deleteUser(@PathVariable Long userId) {
        userService.deleteUser(userId);
    }

    @PutMapping(value = "/users/{userId}/library")
    public User updateGameLibrary(@RequestBody String gameId, @PathVariable Long userId){
        return userService.updateUserLibrary(Long.valueOf(gameId),userId);
    }

    @GetMapping(value = "/users/{userId}/library")
    public Collection<Game> getAllUsersGames(@PathVariable Long userId){
        return userService.getAllUsersGames(userId);
    }

}
