package com.example.demo.Entity;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;

@Entity
@Table (name = "games", uniqueConstraints={@UniqueConstraint(columnNames={"title"})})
public class Game {

    @Id
    @GeneratedValue( strategy = GenerationType.IDENTITY)
    private Long id;
    @NotNull
    private String title;
    @NotNull
    private String studio;
    @NotNull
    private String platform;
    private String imageURL;
    private String summary;
//    @NotNull
//    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "dd/mm/yyyy")
//    private Date dateAdded;
//    @NotNull
//    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "dd/mm/yyyy")
//    private Date yearReleased;

    public Game(){}

    public Game(@NotNull String title, @NotNull String studio, @NotNull String platform, String imageURL, String summary) {
        this.title = title;
        this.studio = studio;
        this.platform = platform;
        this.imageURL = imageURL;
        this.summary = summary;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }


    public String getStudio() {
        return studio;
    }

    public void setStudio(String studio) {
        this.studio = studio;
    }

    public String getPlatform() {
        return platform;
    }

    public void setPlatform(String platform) {
        this.platform = platform;
    }

    public String getImageURL() {
        return imageURL;
    }

    public void setImageURL(String imageURL) {
        this.imageURL = imageURL;
    }

    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    //    public Date getDateAdded() {
//        return dateAdded;
//    }
//
//    public void setDateAdded(Date dateAdded) {
//        this.dateAdded = dateAdded;
//    }
//
//    public Date getYearReleased() {
//        return yearReleased;
//    }
//
//    public void setYearReleased(Date yearReleased) {
//        this.yearReleased = yearReleased;
//    }
//


    @Override
    public String toString() {
        return "Game{" +
                "id=" + id +
                ", title='" + title + '\'' +
                ", studio='" + studio + '\'' +
                ", platform='" + platform + '\'' +
                ", imageURL='" + imageURL + '\'' +
                '}';
    }
}
