package com.example.demo.Service;

import com.example.demo.Entity.Game;
import com.example.demo.Repository.GameRepository;
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

@Service
public class GameService {

    private GameRepository gameRepository;
    private static final Logger logger = LoggerFactory.getLogger(UserService.class);
    private final String igdbURL = "https://api-endpoint.igdb.com/games/?search=";
    private final String igdbURLEnd = "&fields=name,cover,summary";
    private final String igdbKey = "4aafe5d7db305154aa7b60f13bad89bd";
    private RestTemplate restTemplate;


    @Autowired
    public GameService(GameRepository gameRepository, RestTemplateBuilder restTemplateBuilder) {

        this.gameRepository = gameRepository;
        this.restTemplate = restTemplateBuilder.build();
    }

    public Game createGame(Game game){

        String url = igdbURL + game.getTitle() + igdbURLEnd;
        logger.info("About to fetch from URL: " + url);

        HttpHeaders headers = new HttpHeaders();
        headers.set("user-key", "4aafe5d7db305154aa7b60f13bad89bd");
        headers.set("Accept", MediaType.APPLICATION_JSON_VALUE);

        HttpEntity<?> entity = new HttpEntity<>(headers);
        HttpEntity<HashMap[]>  response = restTemplate.exchange(
                url,
                HttpMethod.GET,
                entity,
                HashMap[].class
        );

        Map cover = (Map) response.getBody()[0].get("cover");
        logger.info("cover: " + cover.get("url"));
        game.setImageURL("https:" + cover.get("url"));
        //game.setSummary(response.getBody()[0].get("summary").toString().substring(0,255));
        logger.info(game.getSummary());
        game = this.gameRepository.save(game);
        return game;
    }

    public Collection<Game> findAllGames(){
        return this.gameRepository.findAll();
    }

    public Game deleteGame(Long gameId) {
        Game deleteGame = gameRepository.getOne(gameId);
        gameRepository.delete(deleteGame);
        return deleteGame;
    }

    public Game findGameById(Long gameId) {
        Game game = this.gameRepository.findById(gameId).get();
        return game;
    }

    public Long getGameByName(String name){
        return gameRepository.getGameByName(name);
    }

    public Collection<Game> getGamesByPlatform(String platform) {
        return gameRepository.getAllByPlatform(platform);
    }

    public Game updateGame(Long gameId, Game game) {
       return this.gameRepository.save(game);
    }
}
