package com.example.demo.RepositoryTest;

import com.example.demo.Entity.User;
import com.example.demo.Repository.UserRepository;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.boot.test.autoconfigure.orm.jpa.TestEntityManager;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.context.junit4.SpringRunner;

import static org.assertj.core.api.AssertionsForClassTypes.assertThat;

@RunWith(SpringRunner.class)
@DataJpaTest
@DirtiesContext(classMode = DirtiesContext.ClassMode.BEFORE_EACH_TEST_METHOD)
public class UserRepositoryTest {

    @Autowired
    private TestEntityManager entityManager;

    @Autowired
    private UserRepository userRepository;

//    @Test
//    public void findByNameTest(){
//
//        //given
//        User nafis = new User("nafis", "nafis@fake.com", "1234");
//        entityManager.persist(nafis);
//        entityManager.flush();
//
//        //when
//        User found = userRepository.findByName(nafis.getName());
//
//        //then
//        assertThat(found.getName()).isEqualTo(nafis.getName());
//    }

    @Test
    public void findByIdTest(){

        //given
        User nafis = new User("nafis", "nafis@fake.com", "1234");
        User rachelle = new User("rachelle", "rach@fake.com", "5678");
        entityManager.persist(nafis);
        entityManager.flush();
        entityManager.persist(rachelle);
        entityManager.flush();

        //when
        User found = userRepository.findById(2L).get();

        //then
        assertThat(found.getName()).isEqualTo(rachelle.getName());
    }
}
